﻿using System;
using System.Globalization;
using System.IO;
using System.Net.Sockets;
using System.Runtime.InteropServices;
using System.Threading;

namespace ConsoleApp_test
{
    class Program
    {
        [StructLayout(LayoutKind.Sequential)]
        public struct SYSTEMTIME
        {
            public short wYear;
            public short wMonth;
            public short wDayOfWeek;
            public short wDay;
            public short wHour;
            public short wMinute;
            public short wSecond;
            public short wMilliseconds;
        }

        [DllImport("kernel32.dll", SetLastError = true)]
        public static extern bool SetSystemTime(ref SYSTEMTIME st);

        static void Main(string[] args)
        {
            while (true)
            {
                try
                {
                    var client = new TcpClient("time.nist.gov", 13);
                    using (var streamReader = new StreamReader(client.GetStream()))
                    {
                        Thread.Sleep(1000);

                        //인터넷 시간 불러오기
                        var response = streamReader.ReadToEnd();
                        var utcDateTimeString = response.Substring(7, 17);
                        var localDateTime = DateTime.ParseExact(utcDateTimeString, "yy-MM-dd HH:mm:ss", CultureInfo.InvariantCulture, DateTimeStyles.AssumeUniversal);

                        //pc에 적용하기
                        SYSTEMTIME st = new SYSTEMTIME();
                        st.wYear = (short)1992; // must be short
                        st.wMonth = (short)localDateTime.Month;
                        st.wDay = (short)localDateTime.Day;
                        st.wHour = (short)localDateTime.Hour;
                        st.wMinute = (short)localDateTime.Minute;
                        st.wSecond = (short)localDateTime.Second;
                        st.wMilliseconds = 1;

                        SetSystemTime(ref st);


                        Console.WriteLine(localDateTime );
                    }
                }
                catch (Exception e)
                {
                    Console.WriteLine(e.Message);
                }
            }
        }

       

    }
}
